// FontInstall.cpp: implementation of the CFontInstaller class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "base.h"
#include "FontInstall.h"
#include "utils.h"
#include "regkey.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define REGKEY_FONT "Software\\Microsoft\\Windows\\CurrentVersion\\Fonts"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFontInstaller::CFontInstaller()
{
	char szFontDir[MAX_PATH];
	utils.GetShellFolderPath(CSIDL_FONTS, szFontDir, MAX_PATH);
	fontsDir = szFontDir;
	szErrorMessage = "";
}

CFontInstaller::~CFontInstaller()
{

}

bool CFontInstaller::RegisterFont(CString csFile, CString csFontName)
{
	CRegKey cKey;
	if (cKey.Create( HKEY_LOCAL_MACHINE, REGKEY_FONT) != ERROR_SUCCESS)
	{
		szErrorMessage = "Cannot create a registry key";
		return false;
	}
	if (cKey.SetValue(csFontName) != ERROR_SUCCESS)
	{
		szErrorMessage = "Cannot add a key to the registry";
		return false;
	}
	AddFontResource(csFile);
	SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
	return true;
}

bool CFontInstaller::InstallFont(CString csFile, CString csFontName)
{
	szErrorMessage = "";
	CString filename = csFile;
	filename = filename.Mid(filename.ReverseFind('\\') + 1);
	if (CopyFile(csFile, fontsDir + filename, FALSE) == 0)
	{
		szErrorMessage = "Theme font is already installed or font file missed";
		return false;
	}
	return RegisterFont(csFile, csFontName);
}
