// InstallerConfig.cpp : implementation file
//

#include "stdafx.h"
#include "base.h"
#include "InstallerConfig.h"
#include "ThemeInstaller.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInstallerConfig dialog


CInstallerConfig::CInstallerConfig(CWnd* pParent /*=NULL*/)
	: CDialog(CInstallerConfig::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInstallerConfig)
	//}}AFX_DATA_INIT
}


void CInstallerConfig::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInstallerConfig)
	DDX_Control(pDX, IDC_SAVEWALLPAPERS, m_SaveWallpapers);
	DDX_Control(pDX, IDC_PROMT2REVERT, m_Prompt2Revert);
	DDX_Control(pDX, IDC_INSTALLFONTS, m_InstallFonts);
	DDX_Control(pDX, IDC_EDITBEFORERECYCLE, m_EditBeforeRecycle);
	DDX_Control(pDX, IDC_DEFAULTTHEME, m_DefaultTheme);
	DDX_Control(pDX, IDC_APPLYWALLPAPER, m_ApplyWallpaper);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInstallerConfig, CDialog)
	//{{AFX_MSG_MAP(CInstallerConfig)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInstallerConfig message handlers

BOOL CInstallerConfig::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_EditBeforeRecycle.SetCheck(themeinstaller.bEditThemevars		? BST_CHECKED : BST_UNCHECKED);
	m_Prompt2Revert.SetCheck	(themeinstaller.bRevertPrompt		? BST_CHECKED : BST_UNCHECKED);
	m_SaveWallpapers.SetCheck	(themeinstaller.bOneWallpaper		? BST_CHECKED : BST_UNCHECKED);
	m_ApplyWallpaper.SetCheck	(themeinstaller.bInstallWallpaper	? BST_CHECKED : BST_UNCHECKED);
	m_InstallFonts.SetCheck		(themeinstaller.bInstallFont		? BST_CHECKED : BST_UNCHECKED);
	CheckDlgButton(themeinstaller.bWritePatch ? IDC_WRITEPATCH : IDC_PATCHTHEME, BST_CHECKED);
	m_DefaultTheme.SetWindowText(themeinstaller.szDefaultTheme);
	return TRUE;
}

void CInstallerConfig::OnOK() 
{
	themeinstaller.bEditThemevars		= m_EditBeforeRecycle.GetCheck()== BST_CHECKED;
	themeinstaller.bRevertPrompt		= m_Prompt2Revert.GetCheck()	== BST_CHECKED;
	themeinstaller.bOneWallpaper 		= m_SaveWallpapers.GetCheck()	== BST_CHECKED;
	themeinstaller.bInstallWallpaper	= m_ApplyWallpaper.GetCheck()	== BST_CHECKED;
	themeinstaller.bInstallFont 		= m_InstallFonts.GetCheck()		== BST_CHECKED;
	themeinstaller.bWritePatch			= GetCheckedRadioButton(IDC_PATCHTHEME,IDC_WRITEPATCH) == IDC_WRITEPATCH;
	m_DefaultTheme.GetWindowText(themeinstaller.szDefaultTheme);
	themeinstaller.WriteRegistry();
	CDialog::OnOK();
}

void CInstallerConfig::OnCancel() 
{	
	CDialog::OnCancel();
}

