// OptionDetails.cpp : implementation file
//

#include "stdafx.h"
#include "base.h"
#include "OptionDetails.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionDetails dialog


COptionDetails::COptionDetails(CWnd* pParent /*=NULL*/)
	: CDialog(COptionDetails::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionDetails)
	//}}AFX_DATA_INIT
}


void COptionDetails::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionDetails)
	DDX_Control(pDX, IDC_COMBOSETTING, m_wndComboSetting);
	DDX_Control(pDX, IDC_COMBOMODULE, m_wndComboModule);
	DDX_Control(pDX, IDC_COMBOVALUE, m_wndComboValue);
	DDX_Control(pDX, IDC_COMBOBOOL, m_wndComboBool);
	DDX_Control(pDX, IDC_LISTSETTING, m_wndListSetting);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionDetails, CDialog)
	//{{AFX_MSG_MAP(COptionDetails)
	ON_BN_CLICKED(IDC_SEARCHVALUE, OnSearchvalue)
	ON_BN_CLICKED(IDC_SEARCHBOOL, OnSearchbool)
	ON_CBN_SELCHANGE(IDC_COMBOMODULE, OnSelchangeCombomodule)
	ON_CBN_SELCHANGE(IDC_COMBOSETTING, OnSelchangeCombosetting)
	ON_BN_CLICKED(IDC_CLEARLIST, OnClearlist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionDetails message handlers

BOOL COptionDetails::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	//listbox init
	m_wndListSetting.SetExtendedStyle( LVS_EX_FULLROWSELECT );
	m_wndListSetting.SetHeadings( _T("Setting,120;Value,300") );

	if (settingsipc_client::IsServerPresent())
	{
		FillComboModule();
		FillComboSetting();
	}
	return TRUE;
}


void COptionDetails::SearchValue()
{
	CString szValue;
	LPCSTR i = "not found";
	char buf[BUFSIZE];

	m_wndComboValue.GetWindowText(szValue);

	if (!szValue.IsEmpty())
	{	
		settingsipc_client::GetRCLine(szValue, buf, BUFSIZE, i);
		m_wndListSetting.AddItem(szValue, buf);
	}	
}

void COptionDetails::OnSearchvalue() 
{
	SearchValue();
}

void COptionDetails::SearchBoolValue()
{
	CString szValue;
	m_wndComboBool.GetWindowText(szValue);

	if (!szValue.IsEmpty())
	{	
		BOOL bufbool = settingsipc_client::GetRCBool(szValue, true);
		m_wndListSetting.AddItem(szValue, bufbool ? "TRUE" : "FALSE");
	}
}

void COptionDetails::OnSearchbool() 
{
	SearchBoolValue();
}

void COptionDetails::FillComboModule()
{	
	m_wndComboModule.ResetContent();

	//search projects directory and list projects
	HANDLE hFind;
	WIN32_FIND_DATA dataFind;
	BOOL bMoreFiles = TRUE;

	//set directory for projects
	CString path = utils.toolDir + "lscpfiles\\conf\\rclines\\*.*";
	
	//find first file in the directory
	hFind = FindFirstFile(path, &dataFind);

	while(hFind != INVALID_HANDLE_VALUE && bMoreFiles == TRUE)
	{
		if(dataFind.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY || ( dataFind.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY && dataFind.dwFileAttributes & FILE_ATTRIBUTE_ARCHIVE))
		{
			if (strcmp(dataFind.cFileName, ".") && strcmp(dataFind.cFileName, ".."))
			{
				m_wndComboModule.AddString(dataFind.cFileName);
			}
		}
		bMoreFiles = FindNextFile(hFind, &dataFind);
	}
	FindClose(hFind);
	m_wndComboModule.SetCurSel(0);
}

void COptionDetails::FillComboSetting()
{
	m_wndComboSetting.ResetContent();
	//search projects directory and list projects
	HANDLE hFind;
	WIN32_FIND_DATA dataFind;
	BOOL bMoreFiles = TRUE;

	//set directory for projects
	CString szModule;
	m_wndComboModule.GetLBText(m_wndComboModule.GetCurSel(), szModule);

	CString path = utils.toolDir + "lscpfiles\\conf\\rclines\\" + szModule + "\\*.*";
	
	//find first file in the directory
	hFind = FindFirstFile(path, &dataFind);

	while(hFind != INVALID_HANDLE_VALUE && bMoreFiles == TRUE)
	{
		if(dataFind.dwFileAttributes != FILE_ATTRIBUTE_DIRECTORY)
		{
			if (strcmp(dataFind.cFileName, ".") && strcmp(dataFind.cFileName, ".."))
			{
				m_wndComboSetting.AddString(dataFind.cFileName);
			}
		}
		bMoreFiles = FindNextFile(hFind, &dataFind);
	}
	FindClose(hFind);
	m_wndComboSetting.SetCurSel(0);	
}

void COptionDetails::ReadSettings()
{
	const char i[] = "not found/default";

	CStdioFile f;
	CString szModule;
	CString szSetting;

	m_wndComboModule.GetLBText(m_wndComboModule.GetCurSel(), szModule);
	m_wndComboSetting.GetLBText(m_wndComboSetting.GetCurSel(), szSetting);

	if (f.Open(utils.toolDir + "lscpfiles\\conf\\rclines\\" + szModule + "\\" + szSetting, CFile::modeRead))
	{
		CString line;
		while(f.ReadString(line))
		{
			char buf[BUFSIZE];
			settingsipc_client::GetRCLine(line, buf, BUFSIZE, i);
			CString value = buf;			
			m_wndListSetting.AddItem(line, value == "" ? "not found/default" : value);
		}
		f.Close();
	}
}

void COptionDetails::ReadBoolSettings()
{
	CString szModule;
	CString szSetting;

	m_wndComboModule.GetLBText(m_wndComboModule.GetCurSel(), szModule);
	m_wndComboSetting.GetLBText(m_wndComboSetting.GetCurSel(), szSetting);

	CStdioFile f;
	CString line;

	if (f.Open(utils.toolDir + "lscpfiles\\conf\\rcbools\\" + szModule + "\\" + szSetting, CFile::modeRead))
	{
		while(f.ReadString(line))
		{
		 	BOOL bufbool = settingsipc_client::GetRCBool(line, true);
			m_wndListSetting.AddItem(line, bufbool ? "TRUE" : "FALSE");
		}
		f.Close();
	}
}

void COptionDetails::OnSelchangeCombomodule() 
{
	FillComboSetting();
	m_wndListSetting.DeleteAllItems();
	ReadSettings();
	ReadBoolSettings();		
}

void COptionDetails::OnSelchangeCombosetting() 
{
	m_wndListSetting.DeleteAllItems();
	ReadSettings();
	ReadBoolSettings();
}

void COptionDetails::OnClearlist() 
{
	m_wndListSetting.DeleteAllItems();
}
