// OptionShell.cpp : implementation file
//

#include "stdafx.h"
#include "base.h"
#include "OptionShell.h"
#include "utils.h"
#include "regkey.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define REGKEY_INIMAPPING		"SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\IniFileMapping\\system.ini\\boot"

/////////////////////////////////////////////////////////////////////////////
// COptionShell dialog


COptionShell::COptionShell(CWnd* pParent /*=NULL*/)
	: CDialog(COptionShell::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionShell)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void COptionShell::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionShell)
	DDX_Control(pDX, IDC_CURRENTUSER, m_CurrentUserOnly);
	DDX_Control(pDX, IDC_SHELLPATH, m_wndShellPath);
	DDX_Control(pDX, IDC_SHELLNAME, m_wndShellName);
	DDX_Control(pDX, IDC_LISTSHELLS, m_wndListShells);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COptionShell, CDialog)
	//{{AFX_MSG_MAP(COptionShell)
	ON_BN_CLICKED(IDC_ADDSHELL, OnAddshell)
	ON_BN_CLICKED(IDC_DELSHELL, OnDelshell)
	ON_BN_CLICKED(IDC_SETSHELL, OnSetshell)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_NOTIFY(NM_DBLCLK, IDC_LISTSHELLS, OnDblclkListshells)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionShell message handlers
BOOL COptionShell::OnInitDialog() 
{
	CDialog::OnInitDialog();	
	m_wndListShells.SetExtendedStyle( LVS_EX_FULLROWSELECT );
	m_wndListShells.SetHeadings( _T("Shell Name,150;Path,281") );
	ReadRegistry();
	OSVERSIONINFO osInfo;
	ZeroMemory(&osInfo, sizeof(osInfo));
	osInfo.dwOSVersionInfoSize = sizeof(osInfo);
	GetVersionEx(&osInfo);
	if (osInfo.dwPlatformId != VER_PLATFORM_WIN32_NT)
	{
		m_CurrentUserOnly.EnableWindow(FALSE);
	}
	return TRUE;
}

void COptionShell::OnAddshell() 
{
	CString name;
	CString path;
	m_wndShellName.GetWindowText(name);
	m_wndShellPath.GetWindowText(path);
	if (name != "" && path != "")
	{
		m_wndListShells.AddItem(name, path);
	}
}

void COptionShell::OnDelshell() 
{
	// delete all selected shells from the history
	POSITION p = m_wndListShells.GetFirstSelectedItemPosition();	
	while (p)
	{
		m_wndListShells.DeleteItem(m_wndListShells.GetNextSelectedItem(p));
	}
}

void COptionShell::OnSetshell() 
{
	WriteRegistry();
	// Get the selected items in the control
	POSITION p = m_wndListShells.GetFirstSelectedItemPosition();
	
	while (p)
	{
		int nSelected = m_wndListShells.GetNextSelectedItem(p);
		CString szNewShell;
		szNewShell = m_wndListShells.GetItemText(nSelected,1);
		bool bCurrentUserOnly = IsDlgButtonChecked(IDC_CURRENTUSER) == TRUE;
		utils.SetShell(szNewShell, bCurrentUserOnly);
	}	
}

void COptionShell::OnBrowse() 
{
	CString filt =	"Shell Executables (*.exe)|*.exe|";
	CFileDialog fileDlg(TRUE,"*.exe","*.exe",NULL,filt,this);
	if (utils.bIsNT50)
	{
		fileDlg.m_ofn.lStructSize = sizeof(OPENFILENAMEEX);
	}
	fileDlg.m_ofn.Flags |= OFN_FILEMUSTEXIST;
	fileDlg.m_ofn.lpstrTitle = "Select a Shell executable";
	
	if (fileDlg.DoModal() == IDOK) 
	{
		CWaitCursor bob;
		
		//AfxMessageBox(fileDlg.GetPathName() + "\n" + fileDlg.GetFileTitle());
		m_wndShellPath.SetWindowText(fileDlg.GetPathName());
		m_wndShellName.SetWindowText(fileDlg.GetFileTitle());
    }		
}

void COptionShell::OnDblclkListshells(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnSetshell();
	*pResult = 0;
}

void COptionShell::WriteRegistry()
{
	CString szShellName, szShellPath;

	char szRegKeyName[12] = "ShellName00";
	char szRegKeyPath[12] = "ShellPath00";

	CWinApp* pApp = AfxGetApp();

	for (int i=0; i<5; i++)
	{
		//obtain items' names from the list
		szShellName = m_wndListShells.GetItemText(i,0);
		szShellPath = m_wndListShells.GetItemText(i,1);

		//and write'em to the registry
		szRegKeyName[10] = szRegKeyPath[10] = '1'+i;
		pApp->WriteProfileString("Shells", szRegKeyName, szShellName);
		pApp->WriteProfileString("Shells", szRegKeyPath, szShellPath);
	}
}

void COptionShell::ReadRegistry()
{
	// read shell names and pathes from the registry
	CString szShellName, szShellPath;

	char szRegKeyName[12] = "ShellName00";
	char szRegKeyPath[12] = "ShellPath00";
	
	CWinApp* pApp = AfxGetApp();
  	
	for (int i=0; i<5; i++)
	{
		szRegKeyName[10] = szRegKeyPath[10] = '1'+i;
	 	szShellName = pApp->GetProfileString("Shells", szRegKeyName, "");
	 	szShellPath = pApp->GetProfileString("Shells", szRegKeyPath, "");
		if (szShellName != "" && szShellPath != "")
		{
			m_wndListShells.AddItem(szShellName, szShellPath);
		}
	}

	char buf[1024];
	DWORD bufsize = 1024;
	CRegKey key;
	if (key.Open(HKEY_LOCAL_MACHINE, REGKEY_INIMAPPING) != ERROR_SUCCESS)
		m_CurrentUserOnly.SetCheck(BST_CHECKED);
	{
		if (key.QueryValue(buf,"shell",&bufsize) == ERROR_SUCCESS)
			m_CurrentUserOnly.SetCheck(strnicmp(buf,"USR:",4) == 0 ? BST_CHECKED : BST_UNCHECKED);
		else
			m_CurrentUserOnly.SetCheck(BST_CHECKED);
		key.Close();
	}
}
