// ThemeInstaller.h: interface for the CThemeInstaller class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_THEMEINSTALLER_H__E68EC259_54CD_451D_8E01_022BDFC4459D__INCLUDED_)
#define AFX_THEMEINSTALLER_H__E68EC259_54CD_451D_8E01_022BDFC4459D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CThemeInstaller  
{
public:
	bool ReadWallpaperSettings(CString csThmFile, CString &wall, CString &wallstyle);
	bool PatchFolderOTSv1(CString csFolder);
	bool PatchFileOTSv1(CString csFile);
	bool PatchThemeOTSv1(CString pathtotheme);
	CString toolDir;
	void PrepareToolDir();
	bool RefreshList();
	bool CheckOTSVersion(CString themerc, CHListBox &log);
	void InstallFont(CString themename, CHListBox &log);
	bool CompatibilityPatch(CString pathtotheme);
	CThemeInstaller();
	virtual ~CThemeInstaller();
	bool ReadBoolFromRegistry(CString keyname, bool defvalue);
	CString ReadStringFromRegistry(CString keyname, CString defvalue);
	bool WriteRegistry();
	bool ReadRegistry();
	bool InstallWallpaper(CString themename);
	bool PrepareOTS1Theme(CString csThemeDir, CHListBox &log);
	bool Install(CString zip, CHListBox &log, bool bDontSwitch);
	bool Switch(CString theme);

	// ThemeInstaller's settings
	CString szDefaultTheme;
	bool bEditThemevars;
	bool bInstallFont;
	bool bInstallWallpaper;
	bool bInstallWinamp2;
	bool bInstallWinamp3;
	bool bInstallWindowBlinds;
	bool bOneWallpaper;
	bool bRevertPrompt;
	bool bWritePatch;

};

extern CThemeInstaller themeinstaller;

#endif // !defined(AFX_THEMEINSTALLER_H__E68EC259_54CD_451D_8E01_022BDFC4459D__INCLUDED_)
